import * as constants from './constants';
import { fromJS } from 'immutable';
import * as config from '../../../common/config.js';
import axios from '../../axios_auth.js';
// import axios from 'axios';

//Loading
export const changeLoading = () => {
    return (dispatch) => {
        dispatch({
            type: constants.CHANGE_LOCKTYPE_LOADING,
            data: true,
        });
    }
}

export const changeLead = (lead) => {
    return (dispatch) => {
        dispatch({
            type: constants.CHANGE_LEAD,
            data: lead,
        });
    }
}

//获取搜索内容
export const getSearchlist = (locksearchValue) => {
    return (dispatch) => {
        let lead = localStorage.getItem("locktype/change_lead");
        axios.get(config.LOCALAPI+config.PATHAPI +'contact_detail.json', {
            params: {
                locksearchValue:locksearchValue,
            },
        }).then((res) => {
            const data = res.data;
            if (data.code === 200) {
                // console.log(locksearchValue);
                //console.log(lead);
                dispatch({
                    type: constants.CHANGE_LOCKTYPE_SEARCHLIST,
                    lead:lead,
                    data: data.data,
                    locksearchValue:locksearchValue,
                });
            } else {
                error("请求数据失败");
            }
        }).catch((e) => {
            error(e);
        })
    }
};

export const getchangelocksotreDetail = () =>{
    return(dispatch) =>{
        //请求/product/longle 携带 searchValue（即是用户输入的值） 接口返回用户需要的数据 res
        // 发送一个get请求
        axios.get(config.CLD2API + '/product/longle', {
            // params: {
            //     current: pagination.current,
            //     pageSize: pagination.pageSize,
            //     searchValue:searchValue,
            // },
            // axios请求正确
        }).then((res) => {
            const data = res.data;
            if (data.code === 200) {
                dispatch({
                    type: constants.CHANGE_ALL_LOCKDATAIL,
                    data: fromJS(data.data),
                    recordsTotal:data.recordsTotal,
                });
            } else {
                console.log(data);
            }
            // axios请求错误
        }).catch((e) => {
            console.log(e);
            console.log('error');
        })
    }
};