import * as constants from './constants';
import React from 'react';
//锁定state不可修改，导致错误y
import { fromJS } from 'immutable';
import { Tag } from 'antd';

const defaultState = fromJS({
	locksotreDetail: {},
	loading: true,
	pagination:false,
	columns:[
		{
			title: '',
			dataIndex: 'number',
			key: 'number',
		},
		{
			title: '类型/时间',
			dataIndex: 'status',
			key: 'status',
		},
		{
			title: '服务内容',
			dataIndex: 'product',
			key: 'product',
		},
	],
	data: [
	],
});


export default (state = defaultState, action) => {
	let columns = state.get('columns').toJS();
    switch (action.type) {
		case constants.CHANGE_LOCK_DETAIL_LOADING:
			return state.set('loading', action.data);
		case constants.CHANGE_LOCK_DETAIL:
			return state.merge({
				loading: false,
				locksotreDetail: fromJS(action.data)
			});
		case constants.CHANGE_LOCK_RECORD:
			let reCord='';
			columns.forEach((element,value) => {
				if(element.title==='类型/时间'){
					reCord=value;
				}
				//console.log(value)
			});
			//console.log(columnsBak);
			if(reCord!==''){
				columns[reCord]=renderRecord(columns[reCord]);
			}
			let serVice='';
			columns.forEach((element,value) => {
				if(element.title==='服务内容'){
					serVice=value;
				}
				//console.log(value)
			});
			if(serVice!==''){
				columns[serVice]=renderService(columns[serVice]);
			}
			return state.merge({
				loading: false,
				data: fromJS(action.data),
				//更新记录内容
				columns: fromJS(columns),
			});
		default:
			return state;
	}
}

function renderRecord(columns){
	let columnsTypeTime=columns;
	if(columns.title==='类型/时间'){
		columnsTypeTime = {
			...columns,
			render: (text, record) =>{
				//console.log(record)
				return (
					<div key="2"  >
					{text} <a href="#">{record.client}</a><br></br><a href="#">@{record.category}</a> <span className="text-muted">{record.createTime}</span>
					</div>
			)}
		}
	}
	return columnsTypeTime;
}

function renderService(columns){
	let columnsService=columns;
	if(columns.title==='服务内容'){
		columnsService = {
			...columns,
			render: (text, record) =>{
				//console.log(record)
				return (
					<div key="2">
					{/* <Tag color="#886ab5">{record.productService}</Tag> */}
					{record.productService.map((tag,index) => (
						<Tag className="mb-1" color="#886ab5" key={tag+index}>{tag}</Tag>
					))}
					</div>
			)}
		}
	}
	return columnsService;
}