import * as constants from './constants';
import { fromJS } from 'immutable';
import * as config from '../../../common/config.js';
import axios from '../../../common/axios_auth.js';

export const toggleColumns = (index,support) => {
    return (dispatch) => {
        dispatch({
            type: constants.TOGGLE_COLUMNS,
            data: index,
            support:support,
        });
    }
};
export const toggleColumnsAll = () => {
    return (dispatch) => {
        dispatch({
            type: constants.TOGGLE_COLUMNS_ALL,
        });
    }
};

//排序
export const toggleSorter = () => {
    return (dispatch) => {
        dispatch({
            type: constants.TOGGLE_SORTER,
        });
    }
}
export const changeSortField = (sortField) => {
    return (dispatch) => {
        dispatch({
            type: constants.CHANGE_LOCKSTORE_SORTFIELD,
            data: sortField,
        });
    }
}
export const changeSort = (sort) => {
    return (dispatch) => {
        dispatch({
            type: constants.CHANGE_LOCKSTORE_SORT,
            data: sort,
        });
    }
}
//Loading
export const changeLoading = () => {
    return (dispatch) => {
        dispatch({
            type: constants.CHANGE_LOCKSTORE_LOADING,
            data: true,
        });
    }
}


// searchValue  获得用户输入的值
export const getLockstoreList = (pagination,support,searchValue) =>{
    return(dispatch) =>{
        // console.log('searchValue:'+searchValue);
        //console.log('support:'+searchValue);
        // console.log('typeof:'+typeof searchValue);
        //console.log(support);
        let sortField = localStorage.getItem("product_lock_store_sortField");
        if(sortField===null){
            sortField = support.sortField;
        }
        let sort = localStorage.getItem("product_lock_store_sort");
        if(sort===null){
            sort = support.sort;
        }
        if(typeof searchValue === 'undefined'){
            searchValue = support.searchValue;
        }
        //请求/product/longle 携带 searchValue（即是用户输入的值） 接口返回用户需要的数据 res
        // 发送一个get请求
        axios.get(config.CLD2API + '/product/longle', {
            params: {
                current: pagination.current,
                pageSize: pagination.pageSize,
                sortField:sortField,
                sort:sort,
                searchValue:searchValue,
                
            },
            // axios请求正确
        }).then((res) => {
            const data = res.data;
            //字符串转数组
            // console.log(data.data[0].product.split("+"));
            for(var i=0;i < data.data.length;i++){
                //  console.log(data.data[i].product);
                //  console.log(data.data[i].product.split("+"));
                data.data[i].productList=data.data[i].product.split("+");
            }
            if (data.code === 200) {
                // console.log(searchValue);
                dispatch({
                    type: constants.CHANGE_LOCKSTORE_DATA,
                    data: fromJS(data.data),
                    pagination: pagination,
                    recordsTotal:data.recordsTotal,
                    support:support,
                    searchValue:searchValue,
                });
            } else {
                console.log(data);
            }
            // axios请求错误
        }).catch((e) => {
            console.log(e);
            console.log('error');
        })
    }
};


    // current: pagination.current,    //当前页
    // pageSize: pagination.pageSize,  //每页多少条
    // sortField: sortField,           //排序字段
    // sort: sort,                     //按降序 升级
    // searchValue:searchValue         //检索关键字