import * as constants from './constants';
import React from 'react';
//锁定state不可修改，导致错误y
import { fromJS } from 'immutable';

import { Tag } from 'antd';

const defaultState = fromJS({
	pagination: {
		current: 1,
		pageSize: 10,
		position: ['bottomCenter'],
		showSizeChanger: false
	},
	loading: false,
	columnsNum: 0,
	searchValue: '',
	dataSource: [],
	sortField: 'KEYNUM',
	sort: 'DESC',
	LockstorePopupDetail: {
		locksotreDetail: {},
	},
	columns: [
		{
			title: '锁号',
			dataIndex: 'key_num',
			key: 'key_num',
		},
		{
			title: '产品',
			dataIndex: 'product',
			key: 'product',
		},
		{
			title: '办事处',
			dataIndex: 'category',
			key: 'category',
		},
		// {
		// 	title: '出库时间',
		// 	dataIndex: 'make_day',
		// 	key: 'make_day',
		// },
		// {
		// 	title: '销售/借出/赠送时间',
		// 	dataIndex: 'status',
		// 	key: 'status',
		// },
		{
			title: '责任人',
			dataIndex: 'responsible',
			key: 'responsible',
		},
		{
			title: '状态',
			dataIndex: 'statusT',
			key: 'statusT',
		},
		{
			title: '联系人',
			dataIndex: 'client',
			key: 'client',
		},
	],
	columnsData: [
		{ columnsName: '锁号', columnsValue: true, dataKey: "key_num" },
		{ columnsName: '产品', columnsValue: true, dataKey: "product" },
		{ columnsName: '办事处', columnsValue: true, dataKey: "category" },
		// { columnsName: '出库时间', columnsValue: true, dataKey: "make_day" },
		// { columnsName: '销售/借出/赠送时间', columnsValue: true, dataKey: "status" },
		{ columnsName: '责任人', columnsValue: true, dataKey: "responsible" },
		{ columnsName: '状态', columnsValue: true, dataKey: "statusT" },
		{ columnsName: '联系人', columnsValue: true, dataKey: "client" },

	],
});

export default (state = defaultState, action) => {
	let columns = state.get('columns').toJS();
	let columnsData = state.get('columnsData').toJS();
	let countFalse = 0;
	let columnNumData = 0;

	switch (action.type) {
		//显示列
		case constants.TOGGLE_COLUMNS:
			columnsData[action.data].columnsValue = !columnsData[action.data].columnsValue;
			localStorage.setItem('product_lock_store_Column_' + action.data, columnsData[action.data].columnsValue);
			var columnsBak = refreshColumns(columnsData, columns);
			countFalse = 0;
			for (var i = 0; i < columnsData.length; i++) {
				var isAccept = localStorage.getItem("product_lock_store_Column_" + i);
				if (isAccept === "false") {
					countFalse++;
				}
			}
			columnNumData = columnsData.length - countFalse;
			// console.log(columnsData);
			// console.log(columnsData.length);
			// console.log(countFalse);
			// columnNumData = countFalse;
			let tagIndex='';
			columnsBak.forEach((element,value) => {
				if(element.title==='产品'){
					tagIndex=value;
				}
				//console.log(value)
			});
			//console.log(columnsBak);
			if(tagIndex!==''){
				columnsBak[tagIndex]=renderTag(columnsBak[tagIndex]);
			}

			let atextIndex='';
			columnsBak.forEach((element,value) => {
				if(element.title==='锁号'){
					atextIndex=value;
				}
				//console.log(value)
			});
			//console.log(columnsBak);
			if(atextIndex!==''){
				columnsBak[atextIndex]=renderAtext(columnsBak[atextIndex],action);
			}

			return state.merge({
				columnsData: fromJS(columnsData),
				columns: fromJS(columnsBak),
				columnsNum: columnNumData,
			});
		case constants.TOGGLE_COLUMNS_ALL:
			countFalse = 0;
			for (var i = 0; i <= columnsData.length; i++) {
				var isAccept = localStorage.getItem("product_lock_store_Column_" + i);
				if (isAccept === "false") {
					columnsData[i].columnsValue = false;
					countFalse++;
				}
			}
			columnNumData = columnsData.length - countFalse;
			//console.log(refreshColumns(columnsData));
			var columnsBak = refreshColumns(columnsData, columns);
			return state.merge({
				columnsData: fromJS(columnsData),
				columnsNum: columnNumData,
				columns: fromJS(columnsBak),
			});
		//排序
		case constants.TOGGLE_SORTER:
			var sortField = localStorage.getItem("product_lock_store_sortField");
			var sort = localStorage.getItem("product_lock_store_sort");
			if (sortField !== null && sort !== null) {
				return state.merge({
					sortField: sortField,
					sort: sort
				});
			} else if (sortField !== null) {
				return state.set('sortField', sortField);
			} else if (sort !== null) {
				return state.set('sort', sort);
			}
		case constants.CHANGE_LOCKSTORE_SORTFIELD:
			//console.log(action.data);
			localStorage.setItem('product_lock_store_sortField', action.data);
			return state.set('sortField', action.data);
		case constants.CHANGE_LOCKSTORE_SORT:
			localStorage.setItem('product_lock_store_sort', action.data);
			return state.set('sort', action.data);
		case constants.CHANGE_LOCKSTORE_LOADING:
			return state.set('loading', action.data);
		//表格
		case constants.CHANGE_LOCKSTORE_DATA:
			// console.log(columns[1])
			// let columnsDetail = {
			// 	...columns[0],
			// 	render: (text, record) => <a onClick={() => action.support.handlelockDetailPopups(record.key)} href="#lockDetail" data-toggle="modal" data-target="#lockDetail"  >{text}</a>,
			// }
			// columns[0] = columnsDetail;
			columns[0]=renderAtext(columns[0],action);
			// let columnsProduct = {
			// 	...columns[1],
			// 	render: (text, record) =>(
			// 		<>
			// 			{record.productList.map((tag,index) => (
			// 				<Tag color="#886ab5" key={tag+index}>{tag}</Tag>
			// 			))}
			// 		</>
			// 	)
			// }
			// columns[1] = columnsProduct;
			// if(columns[1].title==='产品'){
			// 	columns[1]=renderTag(columns[1]);
			// }

			//console.log(columns)
			var ti=0;
			columns.forEach((element,value) => {
				if(element.title==='产品'){
					ti=value;
				}
			});

			columns[ti]=renderTag(columns[ti]);
			let pagination = {
				...action.pagination,
				total: action.recordsTotal,
			}
			for (var i = 0; i <= columnsData.length; i++) {
				var isAccept = localStorage.getItem("product_lock_store_Column_" + i);
				if (isAccept === 'false') {
					columnsData[i].columnsValue = false;
				}
			}
			var columnsBak = refreshColumns(columnsData, columns);
			// return state.set('dataSource', action.data);
			return state.merge({
				pagination: fromJS(pagination),
				dataSource: fromJS(action.data),
				loading: false,
				searchValue: action.searchValue,
				columns: fromJS(columns),
			});
		default:
			return state;
	}
}
function refreshColumns(columnsData) {
	let columnsBak = [];
	//columnsBak.push(columns[0]);//默认加载第一列
	for (var i = 0; i < columnsData.length; i++) {
		if (columnsData[i].columnsValue) {
			columnsBak.push({
				title: columnsData[i].columnsName,
				dataIndex: columnsData[i].dataKey,
				key: columnsData[i].dataKey,
			});
		}
	}
	return columnsBak;
};

function renderTag(columns){
	//console.log(columns.title)
	let columnsProduct=columns;
	if(columns.title==='产品'){
		columnsProduct = {
			...columns,
			// render: (text, record) =>(
			// 	<>
			// 		{record.productList.map((tag,index) => (
			// 			<Tag color="#886ab5" key={tag+index}>{tag}</Tag>
			// 		))}


			// 	</>
			// )
			render: (text, record) =>{
				//console.log(record)
				return (
					<>
					{record.productList.map((tag,index) => (
						<Tag color="#886ab5" key={tag+index}>{tag}</Tag>
					))}
					</>
			)}
		}
	}
	return columnsProduct;
}

function renderAtext(columns,action){
	//console.log(columns.title);
	let columnsDetail=columns;
	if(columns.title==='锁号'){
		columnsDetail = {
			...columns,
			render: (text, record) => <a onClick={() => action.support.handlelockDetailPopups(record.key)} href="#lockDetail" data-toggle="modal" data-target="#lockDetail">{text}</a>,
		}
	}
	return columnsDetail;
}